/****************************************************************/
/*   draw_graph.c	      					*/
/****************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "xad.h"

#define	WINDOW_HEIGHT	800
#define	WINDOW_WIDTH	600
#define FONT_NAME       "8x13"

extern Display	*theDisplay;
extern Window	theWindow;
extern GC	theGC;
extern int	theScreen;
extern int	theDepth;
int		entries,set;
XArc		*the_arcs;
XFontStruct     *font_struct;
char            string[20];


#ifdef	NO_FORTRAN_HASH
dp_initialize(void)
#else NO_FORTRAN_HASH
dp_initialize_(void)
#endif NO_FORTRAN_HASH
{
	xad_open_window(100,100,WINDOW_HEIGHT,WINDOW_WIDTH,XAD_WT_1_BW,"Draw Graph");
	XClearWindow(theDisplay,theWindow);
	XFlush(theDisplay);
}

#ifdef	NO_FORTRAN_HASH
dp_draw_graph(float r[], float Fr[], int *ent)
#else NO_FORTRAN_HASH
dp_draw_graph_(float r[], float Fr[], int *ent)
#endif NO_FORTRAN_HASH
{
	int	i,j;
	float	x_point;
	float	y_point;

	free(the_arcs);
	entries=(*ent);
	the_arcs=(XArc *)malloc(sizeof(XArc)*entries);

	XClearArea(theDisplay,theWindow,0,0,WINDOW_HEIGHT,WINDOW_WIDTH,False);

        /* Drawing Axes */
        XDrawLine(theDisplay,theWindow,theGC,60,100,60,700);   /* y axis */
        XDrawLine(theDisplay,theWindow,theGC,40,650,500,650);  /* x axis */

        /* Drawing Text (label axes) */
        font_struct=XLoadQueryFont(theDisplay, FONT_NAME);
        XSetFont(theDisplay, theGC, font_struct->fid);
        (void) strcpy(string, "f(r)");
        XDrawImageString(theDisplay,theWindow,theGC,50,90,string,strlen(string));
        (void) strcpy(string, "r");
        XDrawImageString(theDisplay,theWindow,theGC,510,653,string,strlen(string));
        (void) strcpy(string, "0.1");
        XDrawImageString(theDisplay,theWindow,theGC,90,670,string,strlen(string));
        (void) strcpy(string, "4.0");
        XDrawImageString(theDisplay,theWindow,theGC,445,670,string,strlen(string));

        /* Drawing Graph */
        set=0;
        for(i=(*ent);i>=0;--i)
	{        
		x_point=r[i];
		y_point=Fr[i];

                the_arcs[i].x=x_point*100+50;
                if(y_point<0 || set==1)   /* if y_point<0 then move pixel y location
                                             little bit down to make nice picture */
                   {
                     the_arcs[i].y=653-y_point*100;
                     set=1;
                   }
                else
	             the_arcs[i].y=647-y_point*100; 
		the_arcs[i].width=3;
		the_arcs[i].height=3;
		the_arcs[i].angle1=0;
                if(y_point*100<540.)         /* Is y_point*100 inside y axis? */ 
                     the_arcs[i].angle2=23040;
                else
                     the_arcs[i].angle2=0;
  
              /*  XFillArc(theDisplay, theWindow, theGC,
                         the_arcs[i].x,     the_arcs[i].y,
                         the_arcs[i].width, the_arcs[i].height,
                         the_arcs[i].angle1,the_arcs[i].angle2);

	        XFlush(theDisplay); */                
  	}
    	XFillArcs(theDisplay,theWindow,theGC,the_arcs,entries); 
	XFlush(theDisplay); 
}



